package ij2x.plugin;

import ij.WindowManager;
import ij.IJ;
import ij.ImagePlus;
import ij.ImageStack;
import ij.plugin.PlugIn;

/** This plugin reverses the order of the slices in a stack. */

public class StackReverser implements PlugIn{
    ImagePlus imp;
    private ImageStack stack;

    /*public int setup(String arg, ImagePlus imp) {
        this.imp = imp;
        return PlugInFilter.DOES_ALL+PlugInFilter.NO_UNDO;
    }*/

    public void run(String arg) {
        imp = WindowManager.getCurrentImage();
        if (imp==null)
                {IJ.noImage(); return;}
        stack = imp.getStack();
        if (imp.getStackSize()==1)
            IJ.error("Stack required");
        else
            imp.setStack(null, reverseStack(stack, imp));

    }

    /** Returns a stack with that has the order of the slices
        in 'stack' reversed. */
    public ImageStack reverseStack(ImageStack stack, ImagePlus imp) {
         int n;
         ImageStack stack2 = imp.createEmptyStack();
         while ((n=stack.getSize())>0) {
             stack2.addSlice(stack.getSliceLabel(n), stack.getProcessor(n));
             stack.deleteLastSlice();
         }
         return stack2;
    }
}

